#include <Inventor/Win/SoWin.h>
#include <Inventor/Win/viewers/SoWinExaminerViewer.h>

#include <Inventor/nodes/SoSeparator.h>

#include <Inventor/nodes/SoCone.h>
#include <Inventor/nodes/SoCube.h>
#include <Inventor/nodes/SoSphere.h>

#include <Inventor/nodes/SoMaterial.h>
#include <Inventor/nodes/SoTranslation.h>

#include <Inventor/manips/SoTrackballManip.h>

int
main(int, char ** argv)
{

    HWND window = SoWin::init(argv[0]);
    if (window==NULL) exit(1);

    SoWinExaminerViewer * viewer = new SoWinExaminerViewer(window);

    SoSeparator * root = new SoSeparator;

/*
    // load a scene from file
    SoInput scene;
    scene.openFile("chessboard.iv");
    root = SoDB::readAll(&scene);
*/
    root->ref();


/////////////////////////////////////////

    root->addChild(new SoCube);

    SoTranslation *t = new SoTranslation;
    t->translation.setValue(2, 0, 0);
    root->addChild(t);
    
    root->addChild(new SoTrackballManip);

    SoMaterial *mat = new SoMaterial;
    mat->diffuseColor.setValue(1.0, 0.0, 0.0);  //red
    //mat->transparency = .3f;
    root->addChild(mat);
    
    root->addChild(new SoCone);


/////////////////////////////////////////


    viewer->setSceneGraph(root);
    viewer->show();

    SoWin::show(window);
    SoWin::mainLoop();

    delete viewer;
    root->unref();
    return 0;
}
